/*
 ****************************************************************************
 *
 * This file calls to ASE16.DLL .
 * You must first install the device driver in order the sample will work.
 * The decive driver installation program is in 
 *		[DRIVE]:\[ASEPATH]\DRIVERS\WIN31 - for windows 3.1
 *		[DRIVE]:\[ASEPATH]\DRIVERS\WIN95 - for windows 95
 *
 ****************************************************************************
#include <jni.h>
#include "ase.h"


/*------------------------------------------------------------------------
 * ASE_DRVInit ()
 *
 * Search for the ASEDrive port (0 = auto search).
 * Set the TimeOut response value (5 seconds).
 *------------------------------------------------------------------------*/
SHORT InitDrive() {
	SHORT port;
	SHORT error;

	// set mode port ke PC auto-detect.
	port = 0;

	error = ASE_DRVInit ( port, 5 );

	// jika error=0 maka ASEDrive berhasil ditemukan
	// selain itu terjadi kesalahan.
	return error;
}

/*------------------------------------------------------------------------
 * ASE_MCardOn ()
 *
 * Initialize the ASEDrive : Turn the ASEDrive's power on.
 *	                       	   Reset the card.
 *------------------------------------------------------------------------*/
SHORT TurnOn() {
	SHORT error;
	USHORT CardType = 2;

	error = ASE_MCardOn ( CardType );
	
	// jika error=0 berarti power card sudah on
	// selain itu masih off
	return error;
}

/*------------------------------------------------------------------------
 * ASE_MCardOff
 *
 * Terminate the work with the ASEDrive.
 *------------------------------------------------------------------------*/
SHORT TurnOff() {
	SHORT error;
	error = ASE_MCardOff ();

	// jika error=0 berarti termination berhasil
	return error;
}

int CreateFile(int FileNumber, int FileSize, int ReadPassIndex, int WritePassIndex) {}
int CreatePassword(int Index, int Attemp, char* Password) {}
char* Load(int FileNumber, int Offset, int Size) {}
int Store(int FileNumber, int FileSize, int Offset, int Buffer) {}
int VerifyPassword(int Index, char* Password) {}

void DemonstrateAPI ( HWND hwnd )
{
	SHORT port;
	SHORT error;
	USHORT CardType = 2;
	UCHAR data [ 10 ] = "abcd";

	/*
	 *------------------------------------------------------------------------
	 *	ASE_MDataWrite ()
	 * 
	 * Write the data 'abcd' to the card memory at address 10.
	 *------------------------------------------------------------------------
	 */
	wsprintf ( azBuffer, "-Write the string '%s' to the card memory.", data );
	OutString ( hwnd, azBuffer );

	error = ASE_MDataWrite ( 10, 10, data );

	if ( error == 0 )
	  	OutString ( hwnd, " The data has been written." );
	else
		SendMessage ( hwnd, WM_COMMAND, error, ( LONG ) ERR_EXIT );
		
	/*
	 *------------------------------------------------------------------------
	 * ASE_MDataRead ()
	 *
	 * Read data from the card memory at address 10.
	 *------------------------------------------------------------------------
	 */
	OutString ( hwnd, "-Read from the card memory." );

	error = ASE_MDataRead ( 10, 10, data );

	if ( error == 0 )
	{
		data [ 10 ] = '\0';
	  	wsprintf ( azBuffer, " The data that has been read is: '%s'", data );
		OutString ( hwnd, azBuffer );
	}
	else
		SendMessage ( hwnd, WM_COMMAND, error, ( LONG ) ERR_EXIT );

}
