/* Kelas SmartCard : Menyediakan fungsi-fungsi standar pengaksesan SmartCard dengan Java,
   merupakan implementasi Java Native Interface.
   Dibuat oleh : Iman Budi Setiawan, 1999
*/

public class SmartCard {
 public native short InitDrive ();
 public native short TurnOn();
 public native short TurnOff();
 public native short CreateFile(short FileNumber, short FileSize, short ReadPassIndex, short WritePassIndex);
 public native short CreatePassword(short Index, short Attemp, String Password);
 public native short VerifyPassword(short Index, String Password);
 public native String Load(short FileNumber, short Offset, short FileSize);
 public native short Store(short FileNumber, short Offset, short FileSize, String data);
 public native char[] LoadChar(short FileNumber, short Offset, short FileSize);
 public native short StoreChar(short FileNumber, short Offset, short FileSize, char[] data);

 static {
  System.loadLibrary("asecard");
 }

 // fungsi ini untuk membuat file dalam smartcard
 public short Create(short FileNumber, short FileSize, short ReadPassIndex, short WritePassIndex) {
  short error=0, maxSize=(short)252;

  // baca file, 1 file maksimum 252 byte, biar aman dibuat 252 aja
  // jika ada string ukuran besar disimpan di lebih dari 1 file
  while (FileSize>0 && error==0) {

   // baca file di SmartCard
   if (FileSize>maxSize) {
    error = CreateFile(FileNumber, maxSize, ReadPassIndex, WritePassIndex);
   }
   else
    error = CreateFile(FileNumber, FileSize, ReadPassIndex, WritePassIndex);
   FileNumber += 1;
   FileSize -= maxSize;
  }
  return error;
 }

 // fungsi ini untuk membuka file dalam String
 public String LoadString(short FileNumber, short Offset, short FileSize) {
  short maxSize = (short)252, lenData = maxSize;
  String data, strdata = new String();

  // baca file, 1 file maksimum 255 byte, biar aman dibuat 252 aja
  // jika ada string ukuran besar disimpan di lebih dari 1 file
  while (FileSize>0 && lenData==maxSize) {
   // baca file di SmartCard
   if (FileSize>maxSize)
    data = Load(FileNumber, Offset, maxSize);
   else
    data = Load(FileNumber, Offset, FileSize);
   lenData = (short)data.length();
   System.out.println("--> FileSize = " + FileSize);
   System.out.println("Sebelum concat " + strdata.length() + " dengan " + lenData);
   strdata = (strdata).concat(data);
   System.out.println("Sesudah concat panjangnya : " + strdata.length());
   FileNumber += 1;
   FileSize -= maxSize;
  }
  return strdata;
 }

 // fungsi ini untuk menyimpan ke file dalam String
 public short StoreString(short FileNumber, short Offset, short FileSize, String data) {
  short error=0, maxSize=(short)252;
  String strdata = data, subdata;

  // baca file, 1 file maksimum 255 byte, biar aman dibuat 252 aja
  // jika ada string ukuran besar disimpan di lebih dari 1 file
  while (FileSize>0 && !strdata.equals("") && error==0) {

   // baca file di SmartCard
   if (FileSize>maxSize) {
    subdata = strdata.substring(0, maxSize);
    strdata = strdata.substring(maxSize);
    error = Store(FileNumber, Offset, maxSize, subdata);
    System.out.println("Simpan string sepanjang : " + subdata.length());
   }
   else {
    error = Store(FileNumber, Offset, FileSize, strdata);
    System.out.println("SimpanE string sepanjang : " + strdata.length());
   }
   FileNumber += 1;
   FileSize -= maxSize;
  }
  return error;
 }

 // fungsi ini untuk membuka file dalam bytes
 public byte[] LoadBytes(short FileNumber, short Offset, short FileSize) {
  char[] chr = LoadChar(FileNumber, Offset, FileSize);

  System.out.println("Buka Karakter : " + chr.length);
  String str = new String(chr);
  System.out.println("Buka String : " + str.length());
  byte[] data = str.getBytes();
  System.out.println("Buka Bytes : " + data.length);
  return data;
 }

 // fungsi ini untuk menyimpan ke file dalam bytes
 public short StoreBytes(short FileNumber, short Offset, short FileSize, byte[] data) {
  String str = new String(data);
  System.out.println("Simpan String : " + str.length());

  char[] chr = str.toCharArray();
  System.out.println("Simpan Karakter: " + chr.length);
  return StoreChar (FileNumber, Offset, FileSize, chr);
 }

} 
