import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import java.security.spec.*;
import java.security.*;
import java.io.*;
import javax.crypto.*;
import au.net.aba.crypto.provider.ABAProvider;
import au.net.aba.crypto.*;

public class SmartRSA extends Applet {
	SmartCard ASE = new SmartCard();
	boolean cardPower = false;
	int error;
	
	Label judul = new Label("KEY GENERATOR");
	Label nama = new Label("Nama");
	TextField txtNama = new TextField();
	Label kartu = new Label("Jenis Kartu");
	TextField txtKartu = new TextField();
	Label nokartu = new Label("Nomor Kartu");
	TextField txtNokartu = new TextField();
	Label prv = new Label("Kunci Privat");
	TextArea txtPrv = new TextArea();
	Label pbk = new Label("Kunci Publik");
	TextArea txtPbk = new TextArea();
	Button btnOn = new Button("On");
	Button btnProses = new Button("Proses");
	Button btnBaca = new Button("Baca");
	Button btnOff = new Button("Off");
	Label lblData = new Label("Key Generator ...");
	
	public SmartRSA() {
		Security.addProvider(new ABAProvider());
	}
	
	public void init() {
		setBackground(Color.lightGray);
  		setLayout(null);
       setSize(580,440);
	
	    judul.setFont(new Font("Dialog", Font.BOLD, 14));
  		judul.setBounds(233,10,168,19);
  	
  		nama.setBounds(28,52,59,19);
		kartu.setBounds(28,83,59,19);
		nokartu.setBounds(28,117,111,19);
		txtNama.setBounds(147,51,184,25);
  		txtKartu.setBounds(147,83,184,25);
  		txtNokartu.setBounds(147,115,184,25);
  		prv.setBounds(31,159,95,19);
  		txtPrv.setBounds(146,152,373,89);
  		pbk.setBounds(32,256,92,19);
  		txtPbk.setBounds(146,253,373,98);
  		btnOn.setBounds(174,383,75,25);
  		btnProses.setBounds(270,383,75,25);
  		btnBaca.setBounds(365,383,75,25);
  		btnOff.setBounds(460,383,75,25);
  		lblData.setBounds(28, 410, 200,25);
  		
  		txtPrv.setEditable(false);
  		txtPbk.setEditable(false);
  		
  		btnOn.addActionListener(new ButtonHandler());
  		btnProses.addActionListener(new ButtonHandler());
  		btnBaca.addActionListener(new ButtonHandler());
  		btnOff.addActionListener(new ButtonHandler());

  		add(judul);
		add(nama);
		add(txtNama);
		add(kartu);
		add(txtKartu);
		add(nokartu);
		add(txtNokartu);
		add(prv);
		add(txtPrv);
		add(pbk);
		add(txtPbk);
		add(btnOn);
		add(btnProses);
		add(btnBaca);
		add(btnOff);
		add(lblData);
	}

	class ButtonHandler implements ActionListener {
		public void actionPerformed(ActionEvent e){
			String s=e.getActionCommand();
			if (s.equals("On")) fnOn();
			else if (s.equals("Proses")) fnProses();
			else if (s.equals("Baca")) fnBaca();
			else if (s.equals("Off")) fnOff();
  		}
	}
	
	// sambungkan power ke kartu dan buat file
	 void fnOn() {
		if (cardInit()) cardOn();
	}
	
	void fnProses() {
       String str = ASE.Load((short)10, (short)0, (short)7);
       if (str.equals("WALLET")) lblData.setText("Card has been initialized ...");
       else {
       	lblData.setText("Initialize card now !");
			cardCreateFile();
       }
		//cardUpdate();
		lblData.setText("Generating Process !");
		generateKeys("prv.key", "pbk.key");
		//lblData.setText("Generating Key Finished ...");
	}
	
	void fnBaca() {
		cardRead();
	}
	
	void fnOff() {
		if (cardPower) cardOff();
		System.exit(0);
	}
	
	void generateKeys(String privKeyFile, String pubKeyFile) {
   		try {
      		KeyPairGenerator keyGen = KeyPairGenerator.getInstance("RSA");
      		keyGen.initialize(512, new SecureRandom());
      		KeyPair pair = keyGen.generateKeyPair();

			// dapatkan kunci privat
      		PrivateKey priv = pair.getPrivate();
      		// ubah kunci privat ke byte
      		byte[] encPrivKey = priv.getEncoded();
    		
			// dapatkan kunci publik
      		PublicKey pub = pair.getPublic();
      		// ubah kunci privat ke byte
      		byte[] encPubKey = pub.getEncoded();

			// tulis kunci publik dan kunci privat
    		cardUpdate(encPrivKey, encPubKey);

    	} catch (Exception e) {
      		System.err.println("Caught exception: " + e.toString());
    	}
  	}
   // fungsi dasar untuk inisialisasi kartu
    public boolean cardInit() {
        error = ASE.InitDrive();
        if (error==0) { lblData.setText("Success Initialize Card ..."); return true; }
        lblData.setText("Initialization Failure !");
        return false;
    }

	// fungsi dasar untuk menyalakan kartu
    public void cardOn() {
        error = ASE.TurnOn();
        if (error==0) { lblData.setText("Turn On Hurray ..."); cardPower=true; }
        else lblData.setText("Oh nooo I can't on !");
    }

    // fungsi dasar untuk mematikan kartu
    public void cardOff() {
        error = ASE.TurnOff();
        if (error==0) {
            lblData.setText("I am Off now ... ");
        }
        else lblData.setText("No I still alive!");
    }

	// fungsi dasar untuk verifikasi kartu WALLET
    public void cardVerify() {
        String str = ASE.Load((short)10, (short)0, (short)7);
        if (str.equals("WALLET")) {
            lblData.setText("This is WALLET Card ...");
        }
        else lblData.setText("This is not a WALLET Card !");  
    }

    // fungsi untuk membuat file
    // file no 10 : kartu WALLET
    // file no 20 : nama
    // file no 21 : kartu
    // file no 22 : nokartu
    // file no 30 : kunci privat
    // file no 40 : kunci publik
    public void cardCreateFile() {
        // FileNumber = 10, FileSize = 7, WritePassIndex = 1, ReadPassIndex = 1.
        if (ASE.CreateFile((short)10,(short)7,(short)1,(short)1) == 0) {
            // PasswordNumber = 2, Attemp = 3, Password = "00000000".
            if (ASE.CreatePassword((short)2, (short)3, "00000000") == 0) {
                // FileNumber = 10, Offset = 0, FileSize = 7, data = "WALLET".
                if (ASE.Store((short)10, (short)0, (short)7, "WALLET") == 0) {
                    // FileNumber = 20, FileSize = 20, WritePassIndex = 1, ReadPassIndex = 1.
                    if (ASE.CreateFile((short)20, (short)20, (short)1, (short)1) == 0) {
                        lblData.setText("Identification has been successfully stored ...");
                    }
                    // FileNumber = 21, FileSize = 20, WritePassIndex = 1, ReadPassIndex = 1.
                    if (ASE.CreateFile((short)21, (short)20, (short)1, (short)1) == 0) {
                        lblData.setText("Card has been successfully stored ...");
                    }
                    // FileNumber = 22, FileSize = 20, WritePassIndex = 1, ReadPassIndex = 1.
                    if (ASE.CreateFile((short)22, (short)20, (short)1, (short)1) == 0) {
                        lblData.setText("Card Number has been successfully stored ...");
                    }
                    // FileNumber = 30, FileSize = 348, WritePassIndex = 1, ReadPassIndex = 1.
                    if (ASE.Create((short)30, (short)348, (short)1, (short)1) == 0) {
                        lblData.setText("Private Key has been successfully stored ...");
                    }
                    // FileNumber = 40, FileSize = 140, WritePassIndex = 1, ReadPassIndex = 1.
                    if (ASE.Create((short)40, (short)140, (short)1, (short)1) == 0) {
                        lblData.setText("Publik Key has been successfully stored ...");
                    }
                }
            }
        }
        else lblData.setText("Error store ID !!!");
    }

	public void cardUpdate(byte[] encPrivKey, byte[] encPubKey) {
		// simpan nama
       if (ASE.Store((short)20, (short)0, (short)20, txtNama.getText()) == 0) {
           lblData.setText ("Identification has been successfully stored ...");
       }
       else { lblData.setText ("Identification can't be stored !"); return; }
       // simpan kartu
       if (ASE.Store((short)21, (short)0, (short)20, txtKartu.getText()) == 0) {
           lblData.setText ("Card Name has been successfully stored ...");
       }
       else { lblData.setText ("Identification can't be stored !"); return; }
       // simpan nomor kartu
		if (ASE.Store((short)22, (short)0, (short)20, txtNokartu.getText()) == 0) {
           lblData.setText ("Card Number has been successfully stored ...");
       }
       else { lblData.setText ("Identification can't be stored !"); return; }
		// simpan kunci privat
       if (ASE.StoreBytes((short)30, (short)0, (short)348, encPrivKey) == 0) {
       	lblData.setText ("Private Key has been successfully stored ...");
       }
       else { lblData.setText ("Private Key can't be stored !"); return; }
       // simpan kunci publik
       if (ASE.StoreBytes((short)40, (short)0, (short)140, encPubKey) == 0) {
           lblData.setText ("Public Key has been successfully stored ...");
       }
       else lblData.setText ("Public Key can't be stored !");
   }

    public void cardRead() {
        // if it's WALLET Card then read, else notice
        if ((ASE.Load((short)10, (short)0, (short)7)).equals("WALLET")) {
           txtNama.setText(ASE.Load((short)20, (short)0, (short)20));
           txtKartu.setText(ASE.Load((short)21, (short)0, (short)20));
           txtNokartu.setText(ASE.Load((short)22, (short)0, (short)20));
			byte[] encKey = ASE.LoadBytes((short)30, (short)0, (short)348);
			byte[] encKey2 = ASE.LoadBytes((short)40, (short)0, (short)140);
			//displayPrivKey();
			//displayPubKey();
        }
        else lblData.setText ("It's not WALLET Card !");
    }

	void displayPubKey() {
  		try {
      		PublicKey pub = readPubKey();
			txtPbk.setText(pub.toString());
			//String str = ASE.LoadString((short)40, (short)0, (short)140);
			//txtPbk.setText(str);
			//System.out.println("Panjang publik : " + str.length());
			//System.out.println(pub.getFormat());
      		//System.out.println(pub.getAlgorithm());
      		//System.out.println(pub.toString());
    	} catch (Exception e) {
      		System.err.println("Caught exception: " + e.toString());
    	}
  	}

	void displayPrivKey() {
    	try {
      		PrivateKey priv = readPrivKey();
      		txtPrv.setText(priv.toString());
			//String str = ASE.LoadString((short)30, (short)0, (short)348);
			//txtPrv.setText(str);
			//System.out.println("Panjang private : " + str.length());
      		//System.out.println(priv.getFormat());
      		//System.out.println(priv.getAlgorithm());
      		//System.out.println(priv.toString());
    	} catch (Exception e) {
      		System.err.println("Caught exception: " + e.toString());
    	}
  	}

  	PublicKey readPubKey() {
  		PublicKey pub;
    	try {
      		byte[] encKey = ASE.LoadBytes((short)40, (short)0, (short)140);
      		KeyFactory factory = KeyFactory.getInstance("RSA");
      		X509EncodedKeySpec keySpec = new X509EncodedKeySpec(encKey);
			pub = factory.generatePublic(keySpec);
    	} catch (Exception e) {
      		System.err.println("Caught exception: " + e.toString());
      		return null;
    	}
    	return pub;
  	}

  	PrivateKey readPrivKey() {
    	PrivateKey priv;
    	try {
      		byte[] encKey = ASE.LoadBytes((short)30, (short)0, (short)348);
      		KeyFactory factory = KeyFactory.getInstance("RSA");
     		PKCS8EncodedKeySpec keySpec = new PKCS8EncodedKeySpec(encKey);
      		priv = factory.generatePrivate(keySpec);
    	} catch (Exception e) {
      		System.err.println("Caught exception: " + e.toString());
      		return null;
    	}
    	return priv;
  	}
}